#include <p24fxxxx.h>
#include <timer.h>

/* Configuration Settings */
// OSC Input = Primary with PLL , 8M / 2
// Debug Interface PGEC1, PGED1, Disable JTAG
// Disabld WDT, Clock Switch, Fail Safe Clock Monitor ,IO One Way.

// To Do : Oscillator ] Primary with PLL Mode, IESO_OFFC
_CONFIG2( POSCMOD_HS & IOL1WAY_OFF & FCKSM_CSDCMD & FNOSC_???? & PLLDIV_???? & IESO_OFF ); 

// To Do : Debug ]Ĥ@, JTAGEN_OFFC
_CONFIG1( WDTPS_PS32768 & FWPSA_PR128 & WINDIS_OFF & FWDTEN_OFF & ICS_???? & JTAGEN_OFF ); 

#define SystemFrequency 96000000L / 3 / 1 / 2
#define Timer1Tick ( ( SystemFrequency / 256 ) / Timer1TogglesPerSec )
#define Timer1TogglesPerSec 10

// ŧiTimer1_AȨ禡Aëwno_auto_psvC
void __attribute__( ( interrupt , auto_psv ) ) _T1Interrupt( void )
{
	static unsigned int T1Tick = 0;

	// MTimer1_XСC
	IFS0bits.T1IF = 0;

	if( ++T1Tick > 4 )
	{
		T1Tick = 0;

		// IO PortA(Toggle)C
		LATDbits.LATD0 = !LATDbits.LATD0;
	}
}

// wqۤvDefault_AȨ禡Aëwauto_psvC
void __attribute__( ( interrupt , auto_psv ) ) _DefaultInterrupt( void )
{
	while( 1 );
}

// wqStack Error Trap Service RoutineAëwauto_psvC
void __attribute__( ( interrupt , auto_psv ) ) _StackError( void )
{
	while( 1 );
}

int main( void )
{
	// To Do : ʺAվCPDIV0, CPDIV1CPUu@b32M Hz (Primary Osc. With PLL Mode)
	CLKDIVbits.CPDIV = ????;

	// NIO Port]wƦXAëwI/O PortAC
	TRISDbits.TRISD0 = 0;
	LATDbits.LATD0 = 0;

	// ϥMPLAB C30 Timer FunctionTimer1i]wC
	OpenTimer1( T1_ON & T1_IDLE_CON & T1_GATE_OFF & T1_PS_1_256 & T1_SYNC_EXT_OFF & T1_SOURCE_INT , Timer1Tick );

	// ϥMPLAB C30 Timer FunctionҥTimer1_Aëw䤤_uvC
	ConfigIntTimer1( T1_INT_ON & T1_INT_PRIOR_4 );

	while( 1 );
}
