#include <p24fxxxx.h>
#include <timer.h>
#include "APP026-3_LCM.h"
#include "stdio.h"

/* Configuration Settings */
// OSC Input = Primary
// Debug Interface PGEC1, PGED1, Disable JTAG
// Disabld WDT, Clock Switch, Fail Safe Clock Monitor ,IO One Way.

// To Do : Oscillator ] Primary Mode, IESO_OFFC
_CONFIG2( POSCMOD_HS & IOL1WAY_OFF & FCKSM_CSDCMD & FNOSC_???? & IESO_OFF ); 

// To Do : Debug ]Ĥ@, JTAGEN_OFFC
_CONFIG1( WDTPS_PS32768 & FWPSA_PR128 & WINDIS_OFF & FWDTEN_OFF & ICS_PGx1 & JTAGEN_OFF ); 

#define SystemFrequency ????L / 2
#define Timer1Tick ( ( SystemFrequency / 256 ) / Timer1TogglesPerSec )
#define Timer1TogglesPerSec 10
#define CountPeruSec ( SystemFrequency / 1000000L ) / 1

const unsigned char LCMString1[ ] = "PIC24FJ256GB106 "; 
const unsigned char LCMString2[ ] = "H.Side:"; 
unsigned char LCMBuffer[ 10 ]; 

volatile unsigned char GateTimeDone = 0;
volatile unsigned int HSideCount = 0;

// ŧiTimer1_AȨ禡Aëwno_auto_psvC
void __attribute__( ( interrupt , auto_psv ) ) _T1Interrupt( void )
{
	// MTimer1_XСC
	IFS0bits.T1IF = 0;

	// To Do : ϥMPLAB C30 Timer FunctionŪTMR1G, JHSideCountܼƤC
	HSideCount = ????;

	// To Do : ϥMPLAB C30 Timer FunctionMTMR1C
	WriteTimer1( ???? );

	GateTimeDone = 1;
}

// wqۤvDefault_AȨ禡Aëwauto_psvC
void __attribute__( ( interrupt , auto_psv ) ) _DefaultInterrupt( void )
{
	while( 1 );
}

// wqStack Error Trap Service RoutineAëwauto_psvC
void __attribute__( ( interrupt , auto_psv ) ) _StackError( void )
{
	while( 1 );
}

int main( void )
{
	unsigned int HSideTime = 0;

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );
	LCM_SetCursor( 0 , 1 );
	LCM_PutROMString( LCMString2 );

	// To Do : ϥMPLAB C30 Timer FunctionTimer1i]wC
	OpenTimer1( ???? , ???? );

	// ϥMPLAB C30 Timer FunctionҥTimer1_Aëw䤤_uvC
	ConfigIntTimer1( T1_INT_ON & T1_INT_PRIOR_4 );

	while( 1 )
	{
		Nop( );

		if( GateTimeDone == 1 )
		{
			GateTimeDone = 0;

			HSideTime = HSideCount / CountPeruSec;

			sprintf( ( char * ) LCMBuffer , "%5duS" , HSideTime );
			LCM_SetCursor( 7 , 1 );
			LCM_PutRAMString( LCMBuffer );
		}
	}

	while( 1 );
}
